Gtk::Action Class Reference

An action which can be triggered by a menu or toolbar item. More...

Inheritance diagram for Gtk::Action:
[legend]
Collaboration diagram for Gtk::Action:
[legend]

## Public Types

typedef sigc::slot< void > | SlotActivate
| For instance, void on_activate();. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Public Member Functions

| Action (Action&& src) noexcept
Action& | operator= (Action&& src) noexcept
| ~Action () noexceptoverride
GtkAction* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkAction* | gobj () const
| Provides access to the underlying C GObject. More...
GtkAction* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::ustring | get_name () const
| Returns the name of the action. More...
bool | is_sensitive () const
| Returns whether the action is effectively sensitive. More...
bool | get_sensitive () const
| Returns whether the action itself is sensitive. More...
void | set_sensitive (bool sensitive=true)
| Sets the property_sensitive() property of the action to sensitive. More...
bool | is_visible () const
| Returns whether the action is effectively visible. More...
bool | get_visible () const
| Returns whether the action itself is visible. More...
void | set_visible (bool visible=true)
| Sets the property_visible() property of the action to visible. More...
void | activate ()
| Emits the "activate" signal on the specified action, if it isn't insensitive. More...
Image* | create_icon (IconSize icon_size)
| This function is intended for use by action implementations to create icons displayed in the proxy widgets. More...
MenuItem* | create_menu_item ()
| Creates a menu item widget that proxies for the given action. More...
ToolItem* | create_tool_item ()
| Creates a toolbar item widget that proxies for the given action. More...
Menu* | create_menu ()
| If action provides a Gtk::Menu widget as a submenu for the menu item or the toolbar item it creates, this function returns an instance of that menu. More...
void | connect_proxy (Widget& proxy)
| Connects a widget to an action object as a proxy. More...
void | disconnect_proxy (Widget& proxy)
| Disconnects a proxy widget from an action. More...
Glib::SListHandle< Widget* > | get_proxies ()
| Returns the proxy widgets for an action. More...
Glib::SListHandle< const Widget* > | get_proxies () const
| Returns the proxy widgets for an action. More...
void | connect_accelerator ()
| Installs the accelerator for action if action has an accel path and group. More...
void | disconnect_accelerator ()
| Undoes the effect of one call to connect_accelerator(). More...
Glib::ustring | get_accel_path () const
| Returns the accel path for this action. More...
Glib::SignalProxy< void > | signal_activate ()
| The "activate" signal is emitted when the action is activated. More...
void | set_accel_path (const Glib::ustring& accel_path)
| Sets the accel path for this action. More...
void | set_accel_group (const Glib::RefPtr< AccelGroup >& accel_group)
| Sets the Gtk::AccelGroup in which the accelerator for this action will be installed. More...
void | set_label (const Glib::ustring& label)
| Sets the label of action. More...
Glib::ustring | get_label () const
| Gets the label text of action. More...
void | set_short_label (const Glib::ustring& short_label)
| Sets a shorter label text on action. More...
Glib::ustring | get_short_label () const
| Gets the short label text of action. More...
void | set_tooltip (const Glib::ustring& tooltip)
| Sets the tooltip text on action. More...
Glib::ustring | get_tooltip () const
| Gets the tooltip text of action. More...
void | set_stock_id (const StockID& stock_id)
| Sets the stock id on action. More...
StockID | get_stock_id () const
| Gets the stock id of action. More...
void | set_gicon (const Glib::RefPtr< Gio::Icon >& icon)
| Sets the icon of action. More...
Glib::RefPtr< Gio::Icon > | get_gicon ()
| Gets the gicon of action. More...
Glib::RefPtr< const Gio::Icon > | get_gicon () const
| Gets the gicon of action. More...
void | set_icon_name (const Glib::ustring& icon_name)
| Sets the icon name on action. More...
Glib::ustring | get_icon_name () const
| Gets the icon name of action. More...
void | set_visible_horizontal (bool visible_horizontal=true)
| Sets whether action is visible when horizontal. More...
bool | get_visible_horizontal () const
| Checks whether action is visible when horizontal. More...
void | set_visible_vertical (bool visible_vertical=true)
| Sets whether action is visible when vertical. More...
bool | get_visible_vertical () const
| Checks whether action is visible when horizontal. More...
void | set_is_important (bool is_important=true)
| Sets whether the action is important, this attribute is used primarily by toolbar items to decide whether to show a label or not. More...
bool | get_is_important () const
| Checks whether action is important or not. More...
void | set_always_show_image (bool always_show=true)
| Sets whether action's menu item proxies will ignore the Gtk::Settings::property_gtk_menu_images() setting and always show their image, if available. More...
bool | get_always_show_image () const
| Returns whether action's menu item proxies will ignore the Gtk::Settings::property_gtk_menu_images() setting and always show their image, if available. More...
void | block_activate ()
| Disable activation signals from the action. More...
void | unblock_activate ()
| Reenable activation signals from the action. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| A unique name for the action. More...
Glib::PropertyProxy< Glib::ustring > | property_label ()
| The label used for menu items and buttons that activate this action. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_label () const
| The label used for menu items and buttons that activate this action. More...
Glib::PropertyProxy< Glib::ustring > | property_short_label ()
| A shorter label that may be used on toolbar buttons. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_short_label () const
| A shorter label that may be used on toolbar buttons. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip ()
| A tooltip for this action. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip () const
| A tooltip for this action. More...
Glib::PropertyProxy< StockID > | property_stock_id ()
| The stock icon displayed in widgets representing this action. More...
Glib::PropertyProxy_ReadOnly< StockID > | property_stock_id () const
| The stock icon displayed in widgets representing this action. More...
Glib::PropertyProxy< Glib::RefPtr< Gio::Icon > > | property_gicon ()
| The GIcon being displayed. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::Icon > > | property_gicon () const
| The GIcon being displayed. More...
Glib::PropertyProxy< Glib::ustring > | property_icon_name ()
| The name of the icon from the icon theme. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_icon_name () const
| The name of the icon from the icon theme. More...
Glib::PropertyProxy< bool > | property_visible_horizontal ()
| Whether the toolbar item is visible when the toolbar is in a horizontal orientation. More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible_horizontal () const
| Whether the toolbar item is visible when the toolbar is in a horizontal orientation. More...
Glib::PropertyProxy< bool > | property_visible_vertical ()
| Whether the toolbar item is visible when the toolbar is in a vertical orientation. More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible_vertical () const
| Whether the toolbar item is visible when the toolbar is in a vertical orientation. More...
Glib::PropertyProxy< bool > | property_visible_overflown ()
| When TRUE, toolitem proxies for this action are represented in the toolbar overflow menu. More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible_overflown () const
| When TRUE, toolitem proxies for this action are represented in the toolbar overflow menu. More...
Glib::PropertyProxy< bool > | property_is_important ()
| Whether the action is considered important. More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_important () const
| Whether the action is considered important. More...
Glib::PropertyProxy< bool > | property_hide_if_empty ()
| When TRUE, empty menu proxies for this action are hidden. More...
Glib::PropertyProxy_ReadOnly< bool > | property_hide_if_empty () const
| When TRUE, empty menu proxies for this action are hidden. More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the action is enabled. More...
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the action is enabled. More...
Glib::PropertyProxy< bool > | property_visible ()
| Whether the action is visible. More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the action is visible. More...
Glib::PropertyProxy< Glib::RefPtr< ActionGroup > > | property_action_group ()
| The GtkActionGroup this GtkAction is associated with, or NULL (for internal use). More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< ActionGroup > > | property_action_group () const
| The GtkActionGroup this GtkAction is associated with, or NULL (for internal use). More...
Glib::PropertyProxy< bool > | property_always_show_image ()
| Whether the image will always be shown. More...
Glib::PropertyProxy_ReadOnly< bool > | property_always_show_image () const
| Whether the image will always be shown. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions

static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Action > | create ()
static Glib::RefPtr< Action > | create (const Glib::ustring& name, const Glib::ustring& label=Glib::ustring(), const Glib::ustring& tooltip=Glib::ustring())
| Creates an action. More...
static Glib::RefPtr< Action > | create (const Glib::ustring& name, const Gtk::StockID& stock_id, const Glib::ustring& label=Glib::ustring(), const Glib::ustring& tooltip=Glib::ustring())
| Creates an action with a stock ID. More...
static Glib::RefPtr< Action > | create_with_icon_name (const Glib::ustring& name, const Glib::ustring& icon_name, const Glib::ustring& label, const Glib::ustring& tooltip)
| Create an action with an icon name. More...

## Protected Member Functions

| Action ()
| Creates an empty action. More...
| Action (const Glib::ustring& name, const StockID& stock_id=StockID(), const Glib::ustring& label=Glib::ustring(), const Glib::ustring& tooltip=Glib::ustring())
| Creates an action with a stock ID. More...
| Action (const Glib::ustring& name, const Glib::ustring& icon_name, const Glib::ustring& label=Glib::ustring(), const Glib::ustring& tooltip=Glib::ustring())
| Creates an action with an icon name. More...
void | block_activate_from (Widget& proxy)
| Disables calls to the activate() function by signals on the given proxy widget. More...
void | unblock_activate_from (Widget& proxy)
| Re-enables calls to the activate() function by signals on the given proxy widget. More...
virtual Widget* | create_menu_item_vfunc ()
virtual Widget* | create_tool_item_vfunc ()
virtual void | connect_proxy_vfunc (Widget* proxy)
virtual void | disconnect_proxy_vfunc (Widget* proxy)
virtual void | on_activate ()
| This is a default handler for the signal signal_activate(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexceptoverride
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gtk::Action > | wrap (GtkAction* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

An action which can be triggered by a menu or toolbar item.

Actions represent operations that the user can perform, along with some information about how it should be presented in the user interface. Each action provides methods to create icons, menu items and toolbar items representing itself.

As well as the callback that is called when the action is activated, the following is also associated with the action:

- a name (not translated, for path lookup)
- a label (translated, for display)
- an accelerator
- whether the label indicates a stock id
- a tooltip (optional, translated)
- a toolbar label (optional, shorter than label)

The action will also have some state information:

- visible (shown/hidden)
- sensitive (enabled/disabled)

Apart from regular actions, there are toggle actions, which can be toggled between two states and radio actions, of which only one in a group can be in the "active" state. Other actions can be implemented as Gtk::Action subclasses.

Each action can have one or more proxy menu item, toolbar button or other proxy widgets. Proxies mirror the state of the action (text label, tooltip, icon, visible, sensitive, etc), and should change when the action's state changes. When the proxy is activated, it should activate its action.

## Member Typedef Documentation

typedef sigc::slot<void> Gtk::Action::SlotActivate

For instance, void on_activate();.

## Constructor & Destructor Documentation

Gtk::Action::Action | ( | Action&& | src | ) |

noexcept

Gtk::Action::~Action | ( |  | ) |

override noexcept

Gtk::Action::Action | ( |  | ) |

protected

Creates an empty action.

Gtk::Action::Action | ( | const Glib::ustring & | name,
|  | const StockID& | stock_id = `StockID()`,
|  | const Glib::ustring & | label = `Glib::ustring()`,
|  | const Glib::ustring & | tooltip = `Glib::ustring()`
| ) |  |

explicit protected

Creates an action with a stock ID.

The stock ID is used to set a default icon, text and accelerator for the action.

Parameters

  name | A unique name for the action.
  stock_id | The stock icon to display in widgets representing the action.
  label | The label displayed in menu items and on buttons.
  tooltip | A tooltip for the action.

Gtk::Action::Action | ( | const Glib::ustring & | name,
|  | const Glib::ustring & | icon_name,
|  | const Glib::ustring & | label = `Glib::ustring()`,
|  | const Glib::ustring & | tooltip = `Glib::ustring()`
| ) |  |

explicit protected

Creates an action with an icon name.

The action's icon will reflect the specified icon name in the user's icon theme.

Parameters

  name | A unique name for the action.
  icon_name | An IconTheme icon name used for widgets representing the action.
  label | The label displayed in menu items and on buttons.
  tooltip | A tooltip for the action.

## Member Function Documentation

void Gtk::Action::activate | ( |  | ) |

Emits the "activate" signal on the specified action, if it isn't insensitive.

This gets called by the proxy widgets when they get activated.

It can also be used to manually activate an action.

Since gtkmm 2.4:

void Gtk::Action::block_activate | ( |  | ) |

Disable activation signals from the action.

This is needed when updating the state of your proxy Gtk::Activatable widget could result in calling activate(), this is a convenience function to avoid recursing in those cases (updating toggle state for instance).

Since gtkmm 2.16:

void Gtk::Action::block_activate_from | ( | Widget& | proxy | ) |

protected

Disables calls to the activate() function by signals on the given proxy widget.

This is used to break notification loops for things like check or radio actions.

This function is intended for use by action implementations.

Since gtkmm 2.4:

Deprecated: 2.16: activatables are now responsible for activating the action directly so this doesnt apply anymore.

Parameters

  proxy | A proxy widget.

void Gtk::Action::connect_accelerator | ( |  | ) |

Installs the accelerator for action if action has an accel path and group.

See set_accel_path() and set_accel_group()

Since multiple proxies may independently trigger the installation of the accelerator, the action counts the number of times this function has been called and doesn't remove the accelerator until disconnect_accelerator() has been called as many times.

Since gtkmm 2.4:

void Gtk::Action::connect_proxy | ( | Widget& | proxy | ) |

Connects a widget to an action object as a proxy.

Synchronises various properties of the action with the widget (such as label text, icon, tooltip, etc), and attaches a callback so that the action gets activated when the proxy widget does.

If the widget is already connected to an action, it is disconnected first.

Since gtkmm 2.4:

Deprecated: 2.16: Use Gtk::Activatable::set_related_action() instead.

Parameters

  proxy | The proxy widget.

virtual void Gtk::Action::connect_proxy_vfunc | ( | Widget* | proxy | ) |

protected virtual

static Glib::RefPtr<Action> Gtk::Action::create | ( |  | ) |

static

static Glib::RefPtr<Action> Gtk::Action::create | ( | const Glib::ustring & | name,
|  | const Glib::ustring & | label = `Glib::ustring()`,
|  | const Glib::ustring & | tooltip = `Glib::ustring()`
| ) |  |

static

Creates an action.

Parameters

  name | A unique name for the action.
  label | The label displayed in menu items and on buttons.
  tooltip | A tooltip for the action.

Returns
  A new Action.

static Glib::RefPtr<Action> Gtk::Action::create | ( | const Glib::ustring & | name,
|  | const Gtk::StockID& | stock_id,
|  | const Glib::ustring & | label = `Glib::ustring()`,
|  | const Glib::ustring & | tooltip = `Glib::ustring()`
| ) |  |

static

Creates an action with a stock ID.

The stock ID is used to set a default icon, text and accelerator for the action.

Parameters

  name | A unique name for the action.
  stock_id | The stock icon to display in widgets representing the action.
  label | The label displayed in menu items and on buttons.
  tooltip | A tooltip for the action.

Returns
  A new Action.

Image* Gtk::Action::create_icon | ( | IconSize | icon_size | ) |

This function is intended for use by action implementations to create icons displayed in the proxy widgets.

Since gtkmm 2.4:

Parameters

  icon_size | The size of the icon that should be created.

Returns
  A widget that displays the icon for this action.

Menu* Gtk::Action::create_menu | ( |  | ) |

If action provides a Gtk::Menu widget as a submenu for the menu item or the toolbar item it creates, this function returns an instance of that menu.

Since gtkmm 2.12:

Returns
  The menu item provided by the action, or `nullptr`.

MenuItem* Gtk::Action::create_menu_item | ( |  | ) |

Creates a menu item widget that proxies for the given action.

Since gtkmm 2.4:

Returns
  A menu item connected to the action.

virtual Widget* Gtk::Action::create_menu_item_vfunc | ( |  | ) |

protected virtual

ToolItem* Gtk::Action::create_tool_item | ( |  | ) |

Creates a toolbar item widget that proxies for the given action.

Since gtkmm 2.4:

Returns
  A toolbar item connected to the action.

virtual Widget* Gtk::Action::create_tool_item_vfunc | ( |  | ) |

protected virtual

static Glib::RefPtr<Action> Gtk::Action::create_with_icon_name | ( | const Glib::ustring & | name,
|  | const Glib::ustring & | icon_name,
|  | const Glib::ustring & | label,
|  | const Glib::ustring & | tooltip
| ) |  |

static

Create an action with an icon name.

The action's icon will reflect the specified icon name in the user's icon theme.

Parameters

  name | A unique name for the action.
  icon_name | An IconTheme icon name used for widgets representing the action.
  label | The label displayed in menu items and on buttons.
  tooltip | A tooltip for the action.

Returns
  A new Action.

void Gtk::Action::disconnect_accelerator | ( |  | ) |

Undoes the effect of one call to connect_accelerator().

Since gtkmm 2.4:

void Gtk::Action::disconnect_proxy | ( | Widget& | proxy | ) |

Disconnects a proxy widget from an action.

Does not destroy the widget, however.

Since gtkmm 2.4:

Deprecated: 2.16: Use Gtk::Activatable::set_related_action() instead.

Parameters

  proxy | The proxy widget.

virtual void Gtk::Action::disconnect_proxy_vfunc | ( | Widget* | proxy | ) |

protected virtual

Glib::ustring Gtk::Action::get_accel_path | ( |  | ) | const

Returns the accel path for this action.

Since gtkmm 2.6:

Returns
  The accel path for this action, or `nullptr` if none is set. The returned string is owned by GTK+ and must not be freed or modified.

bool Gtk::Action::get_always_show_image | ( |  | ) | const

Returns whether action's menu item proxies will ignore the Gtk::Settings::property_gtk_menu_images() setting and always show their image, if available.

Since gtkmm 2.20:

Returns
  `true` if the menu item proxies will always show their image.

Glib::RefPtr<Gio::Icon> Gtk::Action::get_gicon | ( |  | ) |

Gets the gicon of action.

Since gtkmm 2.16:

Returns
  The action's Icon if one is set.

Glib::RefPtr<const Gio::Icon> Gtk::Action::get_gicon | ( |  | ) | const

Gets the gicon of action.

Since gtkmm 2.16:

Returns
  The action's Icon if one is set.

Glib::ustring Gtk::Action::get_icon_name | ( |  | ) | const

Gets the icon name of action.

Since gtkmm 2.16:

Returns
  The icon name.

bool Gtk::Action::get_is_important | ( |  | ) | const

Checks whether action is important or not.

Since gtkmm 2.16:

Returns
  Whether action is important.

Glib::ustring Gtk::Action::get_label | ( |  | ) | const

Gets the label text of action.

Since gtkmm 2.16:

Returns
  The label text.

Glib::ustring Gtk::Action::get_name | ( |  | ) | const

Returns the name of the action.

Since gtkmm 2.4:

Returns
  The name of the action. The string belongs to GTK+ and should not be freed.

Glib::SListHandle<Widget*> Gtk::Action::get_proxies | ( |  | ) |

Returns the proxy widgets for an action.

See also Gtk::Widget::get_action().

Since gtkmm 2.4:

Returns
  A SList of proxy widgets. The list is owned by GTK+ and must not be modified.

Glib::SListHandle<const Widget*> Gtk::Action::get_proxies | ( |  | ) | const

Returns the proxy widgets for an action.

See also Gtk::Widget::get_action().

Since gtkmm 2.4:

Returns
  A SList of proxy widgets. The list is owned by GTK+ and must not be modified.

bool Gtk::Action::get_sensitive | ( |  | ) | const

Returns whether the action itself is sensitive.

Note that this doesn't necessarily mean effective sensitivity. See is_sensitive() for that.

Since gtkmm 2.4:

Returns
  `true` if the action itself is sensitive.

Glib::ustring Gtk::Action::get_short_label | ( |  | ) | const

Gets the short label text of action.

Since gtkmm 2.16:

Returns
  The short label text.

StockID Gtk::Action::get_stock_id | ( |  | ) | const

Gets the stock id of action.

Since gtkmm 2.16:

Returns
  The stock id.

Glib::ustring Gtk::Action::get_tooltip | ( |  | ) | const

Gets the tooltip text of action.

Since gtkmm 2.16:

Returns
  The tooltip text.

static GType Gtk::Action::get_type | ( |  | ) |

static

Get the GType for this class, for use with the underlying GObject type system.

bool Gtk::Action::get_visible | ( |  | ) | const

Returns whether the action itself is visible.

Note that this doesn't necessarily mean effective visibility. See is_sensitive() for that.

Since gtkmm 2.4:

Returns
  `true` if the action itself is visible.

bool Gtk::Action::get_visible_horizontal | ( |  | ) | const

Checks whether action is visible when horizontal.

Since gtkmm 2.16:

Returns
  Whether action is visible when horizontal.

bool Gtk::Action::get_visible_vertical | ( |  | ) | const

Checks whether action is visible when horizontal.

Since gtkmm 2.16:

Returns
  Whether action is visible when horizontal.

GtkAction* Gtk::Action::gobj | ( |  | ) |

inline

Provides access to the underlying C GObject.

const GtkAction* Gtk::Action::gobj | ( |  | ) | const

inline

Provides access to the underlying C GObject.

GtkAction* Gtk::Action::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gtk::Action::is_sensitive | ( |  | ) | const

Returns whether the action is effectively sensitive.

Since gtkmm 2.4:

Returns
  `true` if the action and its associated action group are both sensitive.

bool Gtk::Action::is_visible | ( |  | ) | const

Returns whether the action is effectively visible.

Since gtkmm 2.4:

Returns
  `true` if the action and its associated action group are both visible.

virtual void Gtk::Action::on_activate | ( |  | ) |

protected virtual

This is a default handler for the signal signal_activate().

Action& Gtk::Action::operator= | ( | Action&& | src | ) |

noexcept

Glib::PropertyProxy< Glib::RefPtr<ActionGroup> > Gtk::Action::property_action_group | ( |  | ) |

The GtkActionGroup this GtkAction is associated with, or NULL (for internal use).

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<ActionGroup> > Gtk::Action::property_action_group | ( |  | ) | const

The GtkActionGroup this GtkAction is associated with, or NULL (for internal use).

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Action::property_always_show_image | ( |  | ) |

Whether the image will always be shown.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Action::property_always_show_image | ( |  | ) | const

Whether the image will always be shown.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::RefPtr<Gio::Icon> > Gtk::Action::property_gicon | ( |  | ) |

The GIcon being displayed.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gio::Icon> > Gtk::Action::property_gicon | ( |  | ) | const

The GIcon being displayed.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Action::property_hide_if_empty | ( |  | ) |

When TRUE, empty menu proxies for this action are hidden.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Action::property_hide_if_empty | ( |  | ) | const

When TRUE, empty menu proxies for this action are hidden.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::ustring > Gtk::Action::property_icon_name | ( |  | ) |

The name of the icon from the icon theme.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Action::property_icon_name | ( |  | ) | const

The name of the icon from the icon theme.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Action::property_is_important | ( |  | ) |

Whether the action is considered important.

When TRUE, toolitem proxies for this action show text in GTK_TOOLBAR_BOTH_HORIZ mode.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Action::property_is_important | ( |  | ) | const

Whether the action is considered important.

When TRUE, toolitem proxies for this action show text in GTK_TOOLBAR_BOTH_HORIZ mode.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::ustring > Gtk::Action::property_label | ( |  | ) |

The label used for menu items and buttons that activate this action.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Action::property_label | ( |  | ) | const

The label used for menu items and buttons that activate this action.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Action::property_name | ( |  | ) | const

A unique name for the action.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Action::property_sensitive | ( |  | ) |

Whether the action is enabled.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Action::property_sensitive | ( |  | ) | const

Whether the action is enabled.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::ustring > Gtk::Action::property_short_label | ( |  | ) |

A shorter label that may be used on toolbar buttons.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Action::property_short_label | ( |  | ) | const

A shorter label that may be used on toolbar buttons.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< StockID > Gtk::Action::property_stock_id | ( |  | ) |

The stock icon displayed in widgets representing this action.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< StockID > Gtk::Action::property_stock_id | ( |  | ) | const

The stock icon displayed in widgets representing this action.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::ustring > Gtk::Action::property_tooltip | ( |  | ) |

A tooltip for this action.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Action::property_tooltip | ( |  | ) | const

A tooltip for this action.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Action::property_visible | ( |  | ) |

Whether the action is visible.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Action::property_visible | ( |  | ) | const

Whether the action is visible.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Action::property_visible_horizontal | ( |  | ) |

Whether the toolbar item is visible when the toolbar is in a horizontal orientation.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Action::property_visible_horizontal | ( |  | ) | const

Whether the toolbar item is visible when the toolbar is in a horizontal orientation.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Action::property_visible_overflown | ( |  | ) |

When TRUE, toolitem proxies for this action are represented in the toolbar overflow menu.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Action::property_visible_overflown | ( |  | ) | const

When TRUE, toolitem proxies for this action are represented in the toolbar overflow menu.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Action::property_visible_vertical | ( |  | ) |

Whether the toolbar item is visible when the toolbar is in a vertical orientation.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Action::property_visible_vertical | ( |  | ) | const

Whether the toolbar item is visible when the toolbar is in a vertical orientation.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gtk::Action::set_accel_group | ( | const Glib::RefPtr< AccelGroup >& | accel_group | ) |

Sets the Gtk::AccelGroup in which the accelerator for this action will be installed.

Since gtkmm 2.4:

Parameters

  accel_group | A Gtk::AccelGroup or `nullptr`.

void Gtk::Action::set_accel_path | ( | const Glib::ustring & | accel_path | ) |

Sets the accel path for this action.

All proxy widgets associated with the action will have this accel path, so that their accelerators are consistent.

Note that accel_path string will be stored in a Quark. Therefore, if you pass a static string, you can save some memory by interning it first with Glib::intern_static_string().

Since gtkmm 2.4:

Parameters

  accel_path | The accelerator path.

void Gtk::Action::set_always_show_image | ( | bool | always_show = `true` | ) |

Sets whether action's menu item proxies will ignore the Gtk::Settings::property_gtk_menu_images() setting and always show their image, if available.

Use this if the menu item would be useless or hard to use without their image.

Since gtkmm 2.20:

Parameters

  always_show | `true` if menuitem proxies should always show their image.

void Gtk::Action::set_gicon | ( | const Glib::RefPtr< Gio::Icon > & | icon | ) |

Sets the icon of action.

Since gtkmm 2.16:

Parameters

  icon | The Icon to set.

void Gtk::Action::set_icon_name | ( | const Glib::ustring & | icon_name | ) |

Sets the icon name on action.

Since gtkmm 2.16:

Parameters

  icon_name | The icon name to set.

void Gtk::Action::set_is_important | ( | bool | is_important = `true` | ) |

Sets whether the action is important, this attribute is used primarily by toolbar items to decide whether to show a label or not.

Since gtkmm 2.16:

Parameters

  is_important | `true` to make the action important.

void Gtk::Action::set_label | ( | const Glib::ustring & | label | ) |

Sets the label of action.

Since gtkmm 2.16:

Parameters

  label | The label text to set.

void Gtk::Action::set_sensitive | ( | bool | sensitive = `true` | ) |

Sets the property_sensitive() property of the action to sensitive.

Note that this doesn't necessarily mean effective sensitivity. See is_sensitive() for that.

Since gtkmm 2.6:

Parameters

  sensitive | `true` to make the action sensitive.

void Gtk::Action::set_short_label | ( | const Glib::ustring & | short_label | ) |

Sets a shorter label text on action.

Since gtkmm 2.16:

Parameters

  short_label | The label text to set.

void Gtk::Action::set_stock_id | ( | const StockID& | stock_id | ) |

Sets the stock id on action.

Since gtkmm 2.16:

Parameters

  stock_id | The stock id.

void Gtk::Action::set_tooltip | ( | const Glib::ustring & | tooltip | ) |

Sets the tooltip text on action.

Since gtkmm 2.16:

Parameters

  tooltip | The tooltip text.

void Gtk::Action::set_visible | ( | bool | visible = `true` | ) |

Sets the property_visible() property of the action to visible.

Note that this doesn't necessarily mean effective visibility. See is_visible() for that.

Since gtkmm 2.6:

Parameters

  visible | `true` to make the action visible.

void Gtk::Action::set_visible_horizontal | ( | bool | visible_horizontal = `true` | ) |

Sets whether action is visible when horizontal.

Since gtkmm 2.16:

Parameters

  visible_horizontal | Whether the action is visible horizontally.

void Gtk::Action::set_visible_vertical | ( | bool | visible_vertical = `true` | ) |

Sets whether action is visible when vertical.

Since gtkmm 2.16:

Parameters

  visible_vertical | Whether the action is visible vertically.

Glib::SignalProxy< void > Gtk::Action::signal_activate | ( |  | ) |

The "activate" signal is emitted when the action is activated.

Slot Prototype:
  `void on_my_activate()`

void Gtk::Action::unblock_activate | ( |  | ) |

Reenable activation signals from the action.

Since gtkmm 2.16:

void Gtk::Action::unblock_activate_from | ( | Widget& | proxy | ) |

protected

Re-enables calls to the activate() function by signals on the given proxy widget.

This undoes the blocking done by block_activate_from().

This function is intended for use by action implementations.

Since gtkmm 2.4:

Deprecated: 2.16: activatables are now responsible for activating the action directly so this doesnt apply anymore.

Parameters

  proxy | A proxy widget.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::Action > wrap | ( | GtkAction * | object,
|  | bool | take_copy = `false`
| ) |  |

related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/action.h